stages:
  - 🧨unit-tests
  - 🔎code-quality
  - 🐳build
  - 🚢deploy

variables:
  CONTAINER_PORT: 8080
  EXPOSED_PORT: 80

#-----------------------------------------------------------------------------------------
# Includes (remote is possible)
#-----------------------------------------------------------------------------------------
include:
 - local: 'ci/testing/mocha.gitlab-ci.yml'
 - local: 'ci/quality/eslint.gitlab-ci.yml'
 - local: 'ci/metrics/git-quick-stats.gitlab-ci.yml'
 - local: 'ci/kaniko/kaniko.gitlab-ci.yml'
 - local: 'ci/kube/k8s.dsl.yml'

#-----------------------------------------------------------------------------------------
# Tests
#-----------------------------------------------------------------------------------------
🎯:testing:
  stage: 🧨unit-tests
  extends: .mocha:testing
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Quality
#-----------------------------------------------------------------------------------------
🔎:code:quality:eslint:
  stage: 🔎code-quality
  extends: .eslint:analyzer
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

# metrics
🤖:git-analysis:
  stage: 🔎code-quality
  extends: .git-quick-stats:analyzer
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Docker (Kaniko) builds
#-----------------------------------------------------------------------------------------
📦:kaniko:build:
  stage: 🐳build
  extends: .kaniko:builder
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Deploy 🖐️ show the environment panel
#-----------------------------------------------------------------------------------------
🚀:production:deploy:
  stage: 🚢deploy
  extends: .k8s:dsl
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
  environment:
    name: production/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
  script:
    - generate_manifest
    - cat ./kube/simple.web.app.${CI_COMMIT_SHORT_SHA}.yaml
    - apply
    - scale 3

❌:stop:production:deploy:
  stage: 🚢deploy
  extends: .k8s:dsl
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
      when: manual
  allow_failure: true
  environment:
    name: production/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    action: stop
  script:
    - generate_manifest
    - delete_deployment

